<template>
    <div class="list-view">
        <page-title>
            <el-button @click="addRow" type="primary" icon="el-icon-plus" :loading="downloading" class="filter-item">
                新增
            </el-button>
            <el-button @click="download" icon="el-icon-upload2" :loading="downloading" class="filter-item">
                导出
            </el-button>
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="name" label="专利名称"> </el-table-column>
            <el-table-column prop="status" label="状态" :formatter="statusFormatter"> </el-table-column>
            <el-table-column prop="type" label="专利类型" :formatter="typeFormatter"> </el-table-column>
            <el-table-column prop="uwNo" label="寰球案号"> </el-table-column>
            <el-table-column prop="clientPartnerId" label="客户id"> </el-table-column>
            <el-table-column prop="supplierPartnerId" label="供应商"> </el-table-column>
            <el-table-column prop="supplierNo" label="供应商案号"> </el-table-column>
            <el-table-column prop="supplierSubmitPeriod" label="供应商提交期限"> </el-table-column>
            <el-table-column prop="applicantName" label="申请人名称"> </el-table-column>
            <el-table-column prop="applicantEnName" label="申请人英文名称"> </el-table-column>
            <el-table-column prop="applicantAddress" label="申请人地址"> </el-table-column>
            <el-table-column prop="applicantEnAddress" label="申请人英文地址"> </el-table-column>
            <el-table-column prop="inventorName" label="发明人名称"> </el-table-column>
            <el-table-column prop="inventorEnName" label="发明人英文名称"> </el-table-column>
            <el-table-column prop="priorityNo" label="优先权号"> </el-table-column>
            <el-table-column prop="priorityDate" label="优先权日"> </el-table-column>
            <el-table-column prop="priorityCountry" label="优先权国别"> </el-table-column>
            <el-table-column prop="submitPeriod" label="提交期限/内部期限"> </el-table-column>
            <el-table-column prop="officialPeriod" label="官方期限"> </el-table-column>
            <el-table-column prop="applyNo" label="申请号"> </el-table-column>
            <el-table-column prop="applyDate" label="申请日"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'PatentList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/patent/all',
            downloading: false,
            statusOptions: [
                { label: '申请阶段', value: 'APPLY_STAGE' },
                { label: '审查阶段', value: 'REVIEW_STAGE' },
                { label: '授权阶段', value: 'GRANT_STAGE' },
                { label: '已完成', value: 'COMPLETED' }
            ],
            typeOptions: [
                { label: '发明专利', value: 'INVENTION' },
                { label: '实用新型专利', value: 'UTILITY_MODEL' },
                { label: '外观设计专利', value: 'APPEARANCE_DESIGN' }
            ]
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        typeFormatter(row, column, cellValue, index) {
            let selectedOption = this.typeOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return { search: this.search };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/patentEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/patentEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/patent/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/patent/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
